Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.cpp	(revision 2266)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.cpp	(revision 2267)
@@ -747,5 +747,5 @@
       for (int i=0;i<n;i++) ind(i)=index(i) ;
 
-      localElement_ = new CLocalElement(rank, n_glo, ind) ;
+      localElement_ = make_shared<CLocalElement>(rank, n_glo, ind) ;
    }
 
@@ -783,7 +783,7 @@
    void CAxis::computeModelToWorkflowConnector(void)
    { 
-     CLocalView* srcView=getLocalView(CElementView::MODEL) ;
-     CLocalView* dstView=getLocalView(CElementView::WORKFLOW) ;
-     modelToWorkflowConnector_ = new CLocalConnector(srcView, dstView); 
+     shared_ptr<CLocalView> srcView=getLocalView(CElementView::MODEL) ;
+     shared_ptr<CLocalView> dstView=getLocalView(CElementView::WORKFLOW) ;
+     modelToWorkflowConnector_ = make_shared<CLocalConnector>(srcView, dstView); 
      modelToWorkflowConnector_->computeConnector() ;
    }
@@ -834,10 +834,10 @@
       for (auto& rankServer : client->getRanksServerLeader()) globalIndex[rankServer].reference(indGlo.copy()); 
     }
-    remoteElement_[client] = new CDistributedElement(n_glo, globalIndex) ;
+    remoteElement_[client] = make_shared<CDistributedElement>(n_glo, globalIndex) ;
     remoteElement_[client]->addFullView() ;
   }
  
   void CAxis::distributeToServer(CContextClient* client, std::map<int, CArray<size_t,1>>& globalIndex, 
-                                 CScattererConnector* &scattererConnector, const string& axisId)
+                                 shared_ptr<CScattererConnector> &scattererConnector, const string& axisId)
   {
     string serverAxisId = axisId.empty() ? this->getId() : axisId ;
@@ -846,8 +846,8 @@
     this->sendAllAttributesToServer(client, serverAxisId)  ;
 
-    CDistributedElement scatteredElement(n_glo,globalIndex) ;
-    scatteredElement.addFullView() ;
-    scattererConnector = new CScattererConnector(localElement_->getView(CElementView::FULL), scatteredElement.getView(CElementView::FULL), 
-                                                 context->getIntraComm(), client->getRemoteSize()) ;
+    auto scatteredElement = make_shared<CDistributedElement>(n_glo,globalIndex) ;
+    scatteredElement->addFullView() ;
+    scattererConnector = make_shared<CScattererConnector>(localElement_->getView(CElementView::FULL), scatteredElement->getView(CElementView::FULL), 
+                                                          context->getIntraComm(), client->getRemoteSize()) ;
     scattererConnector->computeConnector() ;
     
@@ -866,13 +866,13 @@
     scattererConnector->transfer(localElement_->getView(CElementView::FULL)->getGlobalIndex(),client,event1,message1) ;
 
-    sendDistributedAttributes(client, *scattererConnector, axisId) ;
+    sendDistributedAttributes(client, scattererConnector, axisId) ;
   
     // phase 2 send the mask : data index + mask2D
     CArray<bool,1> maskIn(localElement_->getView(CElementView::WORKFLOW)->getSize());
     CArray<bool,1> maskOut ;
-    CLocalConnector workflowToFull(localElement_->getView(CElementView::WORKFLOW), localElement_->getView(CElementView::FULL)) ;
-    workflowToFull.computeConnector() ;
+    auto workflowToFull = make_shared<CLocalConnector>(localElement_->getView(CElementView::WORKFLOW), localElement_->getView(CElementView::FULL)) ;
+    workflowToFull->computeConnector() ;
     maskIn=true ;
-    workflowToFull.transfer(maskIn,maskOut,false) ;
+    workflowToFull->transfer(maskIn,maskOut,false) ;
 
     // phase 3 : prepare grid scatterer connector to send data from client to server
@@ -880,18 +880,18 @@
     map<int,CArray<bool,1>> maskOut2 ; 
     scattererConnector->transfer(maskOut, maskOut2) ;
-    scatteredElement.addView(CElementView::WORKFLOW, maskOut2) ;
-    scatteredElement.getView(CElementView::WORKFLOW)->getGlobalIndexView(workflowGlobalIndex) ;
+    scatteredElement->addView(CElementView::WORKFLOW, maskOut2) ;
+    scatteredElement->getView(CElementView::WORKFLOW)->getGlobalIndexView(workflowGlobalIndex) ;
     // create new workflow view for scattered element
-    CDistributedElement clientToServerElement(scatteredElement.getGlobalSize(), workflowGlobalIndex) ;
-    clientToServerElement.addFullView() ;
+    auto clientToServerElement = make_shared<CDistributedElement>(scatteredElement->getGlobalSize(), workflowGlobalIndex) ;
+    clientToServerElement->addFullView() ;
     CEventClient event2(getType(), EVENT_ID_AXIS_DISTRIBUTION);
     CMessage message2 ;
     message2<<serverAxisId<<2 ; 
-    clientToServerElement.sendToServer(client, event2, message2) ; 
-    clientToServerConnector_[client] = new CScattererConnector(localElement_->getView(CElementView::WORKFLOW), clientToServerElement.getView(CElementView::FULL), 
-                                                              context->getIntraComm(), client->getRemoteSize()) ;
+    clientToServerElement->sendToServer(client, event2, message2) ; 
+    clientToServerConnector_[client] = make_shared<CScattererConnector>(localElement_->getView(CElementView::WORKFLOW), clientToServerElement->getView(CElementView::FULL), 
+                                                                        context->getIntraComm(), client->getRemoteSize()) ;
     clientToServerConnector_[client]->computeConnector() ;
 
-    clientFromServerConnector_[client] = new CGathererConnector(clientToServerElement.getView(CElementView::FULL), localElement_->getView(CElementView::WORKFLOW));
+    clientFromServerConnector_[client] = make_shared<CGathererConnector>(clientToServerElement->getView(CElementView::FULL), localElement_->getView(CElementView::WORKFLOW));
     clientFromServerConnector_[client]->computeConnector() ;
 
@@ -916,5 +916,5 @@
     if (phasis==0) // receive the remote element to construct the full view
     {
-      localElement_ = new  CLocalElement(context->getIntraCommRank(),event) ;
+      localElement_ = make_shared<CLocalElement>(context->getIntraCommRank(),event) ;
       localElement_->addFullView() ;
       // construct the local dimension and indexes
@@ -937,7 +937,7 @@
     {
       CContext* context = CContext::getCurrent();
-      CDistributedElement* elementFrom = new  CDistributedElement(event) ;
+      shared_ptr<CDistributedElement> elementFrom = make_shared<CDistributedElement>(event) ;
       elementFrom->addFullView() ;
-      gathererConnector_ = new CGathererConnector(elementFrom->getView(CElementView::FULL), localElement_->getView(CElementView::FULL)) ;
+      gathererConnector_ = make_shared<CGathererConnector>(elementFrom->getView(CElementView::FULL), localElement_->getView(CElementView::FULL)) ;
       gathererConnector_->computeConnector() ; 
     }
@@ -945,7 +945,7 @@
     {
 //      delete gathererConnector_ ;
-      elementFrom_ = new  CDistributedElement(event) ;
+      elementFrom_ = make_shared<CDistributedElement>(event) ;
       elementFrom_->addFullView() ;
-//      gathererConnector_ =  new CGathererConnector(elementFrom_->getView(CElementView::FULL), localElement_->getView(CElementView::FULL)) ;
+//      gathererConnector_ =  make_shared<CGathererConnector>(elementFrom_->getView(CElementView::FULL), localElement_->getView(CElementView::FULL)) ;
 //      gathererConnector_ -> computeConnector() ;
     }
@@ -961,14 +961,14 @@
     mask.reference(serverMask.copy()) ;
  
-    serverFromClientConnector_ = new CGathererConnector(elementFrom_->getView(CElementView::FULL), localElement_->getView(CElementView::WORKFLOW)) ;
+    serverFromClientConnector_ = make_shared<CGathererConnector>(elementFrom_->getView(CElementView::FULL), localElement_->getView(CElementView::WORKFLOW)) ;
     serverFromClientConnector_->computeConnector() ;
       
-    serverToClientConnector_ = new CScattererConnector(localElement_->getView(CElementView::WORKFLOW), elementFrom_->getView(CElementView::FULL),
-                                                         context->getIntraComm(), client->getRemoteSize()) ;
+    serverToClientConnector_ = make_shared<CScattererConnector>(localElement_->getView(CElementView::WORKFLOW), elementFrom_->getView(CElementView::FULL),
+                                                                context->getIntraComm(), client->getRemoteSize()) ;
     serverToClientConnector_->computeConnector() ;
   }
   CATCH_DUMP_ATTR
 
-  void CAxis::sendDistributedAttributes(CContextClient* client, CScattererConnector& scattererConnector, const string& axisId)
+  void CAxis::sendDistributedAttributes(CContextClient* client, shared_ptr<CScattererConnector> scattererConnector, const string& axisId)
   {
     string serverAxisId = axisId.empty() ? this->getId() : axisId ;
@@ -981,5 +981,5 @@
         CMessage message ;
         message<<serverAxisId<<string("value") ; 
-        scattererConnector.transfer(value, client, event,message) ;
+        scattererConnector->transfer(value, client, event,message) ;
       }
     }
@@ -991,5 +991,5 @@
         CMessage message ;
         message<<serverAxisId<<string("bounds") ; 
-        scattererConnector.transfer(2, bounds, client, event,message) ;
+        scattererConnector->transfer(2, bounds, client, event,message) ;
       }
     }
@@ -1016,5 +1016,5 @@
         CMessage message ;
         message<<serverAxisId<<string("label")<<maxSize ;
-        scattererConnector.transfer(maxSize, charArray, client, event,message) ;
+        scattererConnector->transfer(maxSize, charArray, client, event,message) ;
       }
     }
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.hpp	(revision 2266)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.hpp	(revision 2267)
@@ -222,9 +222,9 @@
          
         private:
-         CLocalElement* localElement_ = nullptr ;
+         shared_ptr<CLocalElement> localElement_ ;
          void initializeLocalElement(void) ;
         public: 
-         CLocalElement* getLocalElement(void) { if (localElement_==nullptr) initializeLocalElement() ; return localElement_ ; }
-         CLocalView* getLocalView(CElementView::type type) { return getLocalElement()->getView(type) ;}
+         shared_ptr<CLocalElement> getLocalElement(void) { if (localElement_==nullptr) initializeLocalElement() ; return localElement_ ; }
+         shared_ptr<CLocalView> getLocalView(CElementView::type type) { return getLocalElement()->getView(type) ;}
         private:
          void addFullView(void) ;
@@ -233,12 +233,12 @@
 
         private:
-         CLocalConnector* modelToWorkflowConnector_ ;
+         shared_ptr<CLocalConnector> modelToWorkflowConnector_ ;
          void computeModelToWorkflowConnector(void)  ;
         public:
-         CLocalConnector* getModelToWorkflowConnector(void) { if (modelToWorkflowConnector_==nullptr) computeModelToWorkflowConnector() ; return modelToWorkflowConnector_ ;}
+         shared_ptr<CLocalConnector> getModelToWorkflowConnector(void) { if (modelToWorkflowConnector_==nullptr) computeModelToWorkflowConnector() ; return modelToWorkflowConnector_ ;}
        
        public:
          void computeRemoteElement(CContextClient* client, EDistributionType) ;
-         void distributeToServer(CContextClient* client, std::map<int, CArray<size_t,1>>& globalIndex, CScattererConnector* &scattererConnector,
+         void distributeToServer(CContextClient* client, std::map<int, CArray<size_t,1>>& globalIndex, shared_ptr<CScattererConnector>& scattererConnector,
                                  const string& axisId="") ;
 
@@ -246,34 +246,34 @@
          void receivedAxisDistribution(CEventServer& event, int phasis) ;
          void setServerMask(CArray<bool,1>& serverMask, CContextClient* client ) ;
-         void sendDistributedAttributes(CContextClient* client, CScattererConnector& scattererConnector, const string& axisId) ;
+         void sendDistributedAttributes(CContextClient* client, shared_ptr<CScattererConnector> scattererConnector, const string& axisId) ;
          static void recvDistributedAttributes(CEventServer& event) ;
          void recvDistributedAttributes(CEventServer& event, const string& type) ;
        private:
-         map<CContextClient*, CDistributedElement*> remoteElement_ ;
-       public: 
-         CDistributedElement* getRemoteElement(CContextClient* client) {return remoteElement_[client] ;}
-       private:
-         map<CContextClient*, CScattererConnector*> clientToServerConnector_ ;
-       public: 
-         CScattererConnector* getClientToServerConnector(CContextClient* client) { return clientToServerConnector_[client] ;}
-       private:
-         CGathererConnector*  gathererConnector_ ;
+         map<CContextClient*, shared_ptr<CDistributedElement>> remoteElement_ ;
+       public: 
+         shared_ptr<CDistributedElement> getRemoteElement(CContextClient* client) {return remoteElement_[client] ;}
+       private:
+         map<CContextClient*, shared_ptr<CScattererConnector>> clientToServerConnector_ ;
+       public: 
+         shared_ptr<CScattererConnector> getClientToServerConnector(CContextClient* client) { return clientToServerConnector_[client] ;}
+       private:
+         shared_ptr<CGathererConnector>  gathererConnector_ ;
        public:
-         CGathererConnector* getGathererConnector(void) { return gathererConnector_ ;}
-       private:
-         CGathererConnector* serverFromClientConnector_ ;
-         CDistributedElement* elementFrom_ ;
+         shared_ptr<CGathererConnector> getGathererConnector(void) { return gathererConnector_ ;}
+       private:
+         shared_ptr<CGathererConnector> serverFromClientConnector_ ;
+         shared_ptr<CDistributedElement> elementFrom_ ;
        public:
-        CGathererConnector* getServerFromClientConnector(void) { return serverFromClientConnector_ ;}
-
-       private:
-         CScattererConnector*  serverToClientConnector_ = nullptr ;
-       public: 
-         CScattererConnector* getServerToClientConnector(void) { return serverToClientConnector_ ;} 
-
-       private:
-          map<CContextClient*,CGathererConnector*>  clientFromServerConnector_  ;
-       public: 
-         CGathererConnector* getClientFromServerConnector(CContextClient* client) { return clientFromServerConnector_[client] ;} 
+        shared_ptr<CGathererConnector> getServerFromClientConnector(void) { return serverFromClientConnector_ ;}
+
+       private:
+         shared_ptr<CScattererConnector> serverToClientConnector_ = nullptr ;
+       public: 
+         shared_ptr<CScattererConnector> getServerToClientConnector(void) { return serverToClientConnector_ ;} 
+
+       private:
+          map<CContextClient*,shared_ptr<CGathererConnector>>  clientFromServerConnector_  ;
+       public: 
+        shared_ptr<CGathererConnector> getClientFromServerConnector(CContextClient* client) { return clientFromServerConnector_[client] ;} 
 
          DECLARE_REF_FUNC(Axis,axis)
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/domain.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/domain.cpp	(revision 2266)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/domain.cpp	(revision 2267)
@@ -1740,6 +1740,6 @@
       // testing ?
      /*
-      CLocalView* local = localElement_->getView(CElementView::WORKFLOW) ;
-      CLocalView* model = localElement_->getView(CElementView::MODEL) ;
+      shared_ptr<CLocalView> local = localElement_->getView(CElementView::WORKFLOW) ;
+      shared_ptr<CLocalView> model = localElement_->getView(CElementView::MODEL) ;
 
       CLocalConnector test1(model, local) ;
@@ -1773,5 +1773,5 @@
       for(int ij=0; ij<nij ; ij++) ij_index(ij) = i_index(ij)+j_index(ij)*ni_glo ;
       int rank = CContext::getCurrent()->getIntraCommRank() ;
-      localElement_ = new CLocalElement(rank, ni_glo*nj_glo, ij_index) ;
+      localElement_ = make_shared<CLocalElement>(rank, ni_glo*nj_glo, ij_index) ;
    }
 
@@ -1830,7 +1830,7 @@
    void CDomain::computeModelToWorkflowConnector(void)
    { 
-     CLocalView* srcView=getLocalView(CElementView::MODEL) ;
-     CLocalView* dstView=getLocalView(CElementView::WORKFLOW) ;
-     modelToWorkflowConnector_ = new CLocalConnector(srcView, dstView); 
+     shared_ptr<CLocalView> srcView=getLocalView(CElementView::MODEL) ;
+     shared_ptr<CLocalView> dstView=getLocalView(CElementView::WORKFLOW) ;
+     modelToWorkflowConnector_ = make_shared<CLocalConnector>(srcView, dstView); 
      modelToWorkflowConnector_->computeConnector() ;
    }
@@ -1989,5 +1989,5 @@
       for (auto& rankServer : client->getRanksServerLeader()) globalIndex[rankServer] = indGlo ; 
     }
-    remoteElement_[client] = new CDistributedElement(ni_glo*nj_glo, globalIndex) ;
+    remoteElement_[client] = make_shared<CDistributedElement>(ni_glo*nj_glo, globalIndex) ;
     remoteElement_[client]->addFullView() ;
   }
@@ -1997,5 +1997,5 @@
 
   void CDomain::distributeToServer(CContextClient* client, map<int, CArray<size_t,1>>& globalIndex,
-                                   CScattererConnector* &scattererConnector, const string& domainId)
+                                   shared_ptr<CScattererConnector> &scattererConnector, const string& domainId)
   TRY
   {
@@ -2005,8 +2005,8 @@
     this->sendAllAttributesToServer(client, serverDomainId)  ;
 
-    CDistributedElement scatteredElement(ni_glo*nj_glo, globalIndex) ;
-    scatteredElement.addFullView() ;
-    scattererConnector = new CScattererConnector(localElement_->getView(CElementView::FULL), scatteredElement.getView(CElementView::FULL), 
-                                           context->getIntraComm(), client->getRemoteSize()) ;
+    auto scatteredElement = make_shared<CDistributedElement>(ni_glo*nj_glo, globalIndex) ;
+    scatteredElement->addFullView() ;
+    scattererConnector = make_shared<CScattererConnector>(localElement_->getView(CElementView::FULL), scatteredElement->getView(CElementView::FULL), 
+                                                          context->getIntraComm(), client->getRemoteSize()) ;
     scattererConnector->computeConnector() ;
 
@@ -2025,5 +2025,5 @@
     scattererConnector->transfer(localElement_->getView(CElementView::FULL)->getGlobalIndex(),client,event1,message1) ;
     
-    sendDistributedAttributes(client, *scattererConnector, domainId) ;
+    sendDistributedAttributes(client, scattererConnector, domainId) ;
 
   
@@ -2031,8 +2031,8 @@
     CArray<bool,1> maskIn(localElement_->getView(CElementView::WORKFLOW)->getSize());
     CArray<bool,1> maskOut ;
-    CLocalConnector workflowToFull(localElement_->getView(CElementView::WORKFLOW), localElement_->getView(CElementView::FULL)) ;
-    workflowToFull.computeConnector() ;
+    auto workflowToFull = make_shared<CLocalConnector>(localElement_->getView(CElementView::WORKFLOW), localElement_->getView(CElementView::FULL)) ;
+    workflowToFull->computeConnector() ;
     maskIn=true ;
-    workflowToFull.transfer(maskIn,maskOut,false) ;
+    workflowToFull->transfer(maskIn,maskOut,false) ;
 
 
@@ -2041,18 +2041,18 @@
     map<int,CArray<bool,1>> maskOut2 ; 
     scattererConnector->transfer(maskOut, maskOut2, false) ;
-    scatteredElement.addView(CElementView::WORKFLOW, maskOut2) ;
-    scatteredElement.getView(CElementView::WORKFLOW)->getGlobalIndexView(workflowGlobalIndex) ;
+    scatteredElement->addView(CElementView::WORKFLOW, maskOut2) ;
+    scatteredElement->getView(CElementView::WORKFLOW)->getGlobalIndexView(workflowGlobalIndex) ;
     // create new workflow view for scattered element
-    CDistributedElement clientToServerElement(scatteredElement.getGlobalSize(), workflowGlobalIndex) ;
-    clientToServerElement.addFullView() ;
+    auto clientToServerElement = make_shared<CDistributedElement>(scatteredElement->getGlobalSize(), workflowGlobalIndex) ;
+    clientToServerElement->addFullView() ;
     CEventClient event2(getType(), EVENT_ID_DOMAIN_DISTRIBUTION);
     CMessage message2 ;
     message2<<serverDomainId<<2 ; 
-    clientToServerElement.sendToServer(client, event2, message2) ; 
-    clientToServerConnector_[client] = new CScattererConnector(localElement_->getView(CElementView::WORKFLOW), clientToServerElement.getView(CElementView::FULL),
-                                                               context->getIntraComm(), client->getRemoteSize()) ;
+    clientToServerElement->sendToServer(client, event2, message2) ; 
+    clientToServerConnector_[client] = make_shared<CScattererConnector>(localElement_->getView(CElementView::WORKFLOW), clientToServerElement->getView(CElementView::FULL),
+                                                                        context->getIntraComm(), client->getRemoteSize()) ;
     clientToServerConnector_[client]->computeConnector() ;
 
-    clientFromServerConnector_[client] = new CGathererConnector(clientToServerElement.getView(CElementView::FULL), localElement_->getView(CElementView::WORKFLOW));
+    clientFromServerConnector_[client] = make_shared<CGathererConnector>(clientToServerElement->getView(CElementView::FULL), localElement_->getView(CElementView::WORKFLOW));
     clientFromServerConnector_[client]->computeConnector() ;
 
@@ -2076,5 +2076,5 @@
     if (phasis==0) // receive the remote element to construct the full view
     {
-      localElement_ = new  CLocalElement(context->getIntraCommRank(),event) ;
+      localElement_ = make_shared<CLocalElement>(context->getIntraCommRank(),event) ;
       localElement_->addFullView() ;
       // construct the local dimension and indexes
@@ -2102,7 +2102,7 @@
     {
       CContext* context = CContext::getCurrent();
-      CDistributedElement* elementFrom = new  CDistributedElement(event) ;
+      shared_ptr<CDistributedElement> elementFrom = make_shared<CDistributedElement>(event) ;
       elementFrom->addFullView() ;
-      gathererConnector_ = new CGathererConnector(elementFrom->getView(CElementView::FULL), localElement_->getView(CElementView::FULL)) ;
+      gathererConnector_ = make_shared<CGathererConnector>(elementFrom->getView(CElementView::FULL), localElement_->getView(CElementView::FULL)) ;
       gathererConnector_->computeConnector() ; 
     }
@@ -2110,7 +2110,7 @@
     {
 //      delete gathererConnector_ ;
-      elementFrom_ = new  CDistributedElement(event) ;
+      elementFrom_ = make_shared<CDistributedElement>(event) ;
       elementFrom_->addFullView() ;
-//      gathererConnector_ =  new CGathererConnector(elementFrom_->getView(CElementView::FULL), localElement_->getView(CElementView::FULL)) ;
+//      gathererConnector_ =  make_shared<CGathererConnector>(elementFrom_->getView(CElementView::FULL), localElement_->getView(CElementView::FULL)) ;
 //      gathererConnector_ -> computeConnector() ;
     }
@@ -2127,9 +2127,9 @@
     mask_1d.reference(serverMask.copy()) ;
  
-    serverFromClientConnector_ = new CGathererConnector(elementFrom_->getView(CElementView::FULL), localElement_->getView(CElementView::WORKFLOW)) ;
+    serverFromClientConnector_ = make_shared<CGathererConnector>(elementFrom_->getView(CElementView::FULL), localElement_->getView(CElementView::WORKFLOW)) ;
     serverFromClientConnector_->computeConnector() ;
       
-    serverToClientConnector_ = new CScattererConnector(localElement_->getView(CElementView::WORKFLOW), elementFrom_->getView(CElementView::FULL),
-                                                       context->getIntraComm(), client->getRemoteSize()) ;
+    serverToClientConnector_ = make_shared<CScattererConnector>(localElement_->getView(CElementView::WORKFLOW), elementFrom_->getView(CElementView::FULL),
+                                                                context->getIntraComm(), client->getRemoteSize()) ;
     serverToClientConnector_->computeConnector() ;
   }
@@ -2137,5 +2137,5 @@
 
 
-  void CDomain::sendDistributedAttributes(CContextClient* client, CScattererConnector& scattererConnector,  const string& domainId)
+  void CDomain::sendDistributedAttributes(CContextClient* client, shared_ptr<CScattererConnector> scattererConnector,  const string& domainId)
   {
     string serverDomainId = domainId.empty() ? this->getId() : domainId ;
@@ -2148,5 +2148,5 @@
         CMessage message ;
         message<<serverDomainId<<string("lon") ; 
-        scattererConnector.transfer(lonvalue, client, event,message) ;
+        scattererConnector->transfer(lonvalue, client, event,message) ;
       }
       
@@ -2155,5 +2155,5 @@
         CMessage message ;
         message<<serverDomainId<<string("lat") ; 
-        scattererConnector.transfer(latvalue, client, event, message) ;
+        scattererConnector->transfer(latvalue, client, event, message) ;
       }
     }
@@ -2165,5 +2165,5 @@
         CMessage message ;
         message<<serverDomainId<<string("boundslon") ; 
-        scattererConnector.transfer(nvertex, bounds_lonvalue, client, event, message ) ;
+        scattererConnector->transfer(nvertex, bounds_lonvalue, client, event, message ) ;
       }
 
@@ -2172,5 +2172,5 @@
         CMessage message ;
         message<<serverDomainId<<string("boundslat") ; 
-        scattererConnector.transfer(nvertex, bounds_latvalue, client, event, message ) ;
+        scattererConnector->transfer(nvertex, bounds_latvalue, client, event, message ) ;
       }
     }
@@ -2181,5 +2181,5 @@
       CMessage message ;
       message<<serverDomainId<<string("area") ; 
-      scattererConnector.transfer(areavalue, client, event,message) ;
+      scattererConnector->transfer(areavalue, client, event,message) ;
     }
   }
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/domain.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/domain.hpp	(revision 2266)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/domain.hpp	(revision 2267)
@@ -285,10 +285,10 @@
        //////////////////////////////////////////////////////////////////////////////////////
        private:
-         CLocalElement* localElement_ = nullptr ;
+         shared_ptr<CLocalElement> localElement_ = nullptr ;
          void initializeLocalElement(void) ;
        
        public:  
-         CLocalElement* getLocalElement(void) { if (localElement_==nullptr) initializeLocalElement() ; return localElement_ ; }
-         CLocalView* getLocalView(CElementView::type type) { return getLocalElement()->getView(type) ;}
+         shared_ptr<CLocalElement> getLocalElement(void) { if (localElement_==nullptr) initializeLocalElement() ; return localElement_ ; }
+         shared_ptr<CLocalView> getLocalView(CElementView::type type) { return getLocalElement()->getView(type) ;}
        
        private:  
@@ -298,12 +298,12 @@
         
        private:
-         CLocalConnector* modelToWorkflowConnector_ ;
+         shared_ptr<CLocalConnector> modelToWorkflowConnector_ ;
          void computeModelToWorkflowConnector(void)  ;
        public:
-         CLocalConnector* getModelToWorkflowConnector(void) { if (modelToWorkflowConnector_==nullptr) computeModelToWorkflowConnector() ; return modelToWorkflowConnector_ ;}
+         shared_ptr<CLocalConnector> getModelToWorkflowConnector(void) { if (modelToWorkflowConnector_==nullptr) computeModelToWorkflowConnector() ; return modelToWorkflowConnector_ ;}
 
        public:
          void computeRemoteElement(CContextClient* client, EDistributionType) ;
-         void distributeToServer(CContextClient* client, std::map<int, CArray<size_t,1>>& globalIndex, CScattererConnector* &scattererConnector,
+         void distributeToServer(CContextClient* client, std::map<int, CArray<size_t,1>>& globalIndex, shared_ptr<CScattererConnector> &scattererConnector,
                                  const string& domainId="") ;
 
@@ -311,5 +311,5 @@
          void receivedDomainDistribution(CEventServer& event, int phasis) ;
 
-         void sendDistributedAttributes(CContextClient* client, CScattererConnector& scaterrerConnector, const string& domainId) ;
+         void sendDistributedAttributes(CContextClient* client, shared_ptr<CScattererConnector> scaterrerConnector, const string& domainId) ;
          static void recvDistributedAttributes(CEventServer& event) ;
          void recvDistributedAttributes(CEventServer& event, const string& type) ;
@@ -317,31 +317,31 @@
 
        private:
-         map<CContextClient*, CDistributedElement*> remoteElement_ ;
+         map<CContextClient*, shared_ptr<CDistributedElement>> remoteElement_ ;
        public: 
-         CDistributedElement* getRemoteElement(CContextClient* client) {return remoteElement_[client] ;}
-       private:
-         map<CContextClient*, CScattererConnector*> clientToServerConnector_ ;
+         shared_ptr<CDistributedElement> getRemoteElement(CContextClient* client) {return remoteElement_[client] ;}
+       private:
+         map<CContextClient*, shared_ptr<CScattererConnector>> clientToServerConnector_ ;
        public: 
-         CScattererConnector* getClientToServerConnector(CContextClient* client) { return clientToServerConnector_[client] ;}
-       
-       private:
-         CGathererConnector*  gathererConnector_ ;
-       public:
-         CGathererConnector* getGathererConnector(void) { return gathererConnector_ ;}
+         shared_ptr<CScattererConnector> getClientToServerConnector(CContextClient* client) { return clientToServerConnector_[client] ;}
+       
+       private:
+         shared_ptr<CGathererConnector>  gathererConnector_ ;
+       public:
+         shared_ptr<CGathererConnector> getGathererConnector(void) { return gathererConnector_ ;}
         private:
-         CGathererConnector* serverFromClientConnector_ ;
-         CDistributedElement* elementFrom_ ;
-       public:
-         CGathererConnector* getServerFromClientConnector(void) { return serverFromClientConnector_ ;}
-
-       private:
-         CScattererConnector*  serverToClientConnector_ = nullptr ;
+         shared_ptr<CGathererConnector> serverFromClientConnector_ ;
+         shared_ptr<CDistributedElement> elementFrom_ ;
+       public:
+         shared_ptr<CGathererConnector> getServerFromClientConnector(void) { return serverFromClientConnector_ ;}
+
+       private:
+         shared_ptr<CScattererConnector>  serverToClientConnector_ = nullptr ;
        public: 
-         CScattererConnector* getServerToClientConnector(void) { return serverToClientConnector_ ;} 
-
-       private:
-         map<CContextClient*,CGathererConnector*>  clientFromServerConnector_  ;
+         shared_ptr<CScattererConnector> getServerToClientConnector(void) { return serverToClientConnector_ ;} 
+
+       private:
+         map<CContextClient*,shared_ptr<CGathererConnector>>  clientFromServerConnector_  ;
        public: 
-         CGathererConnector* getClientFromServerConnector(CContextClient* client) { return clientFromServerConnector_[client] ;}        
+         shared_ptr<CGathererConnector> getClientFromServerConnector(CContextClient* client) { return clientFromServerConnector_[client] ;}        
          
 
